Unit ftfgc_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, FTF1C_p;

procedure ftfgc(var ARE :Array of Real; var AIM :Array of Real;
                var N :Integer; L :Integer; M :Integer; var P :Real;
                var XRE :Array of Real; var XIM :Array of Real);

implementation

procedure ftfgc(var ARE :Array of Real; var AIM :Array of Real;
                var N :Integer; L :Integer; M :Integer; var P :Real;
                var XRE :Array of Real; var XIM :Array of Real);
var
I,J,K,JN,JJ,JK,JSN :Integer;
Q,T,C,S,CO,SI,RR,RI :Real;
const
SYS003 :Real = 6.2831853071795864769252867665590;
label
_1,_2,_3,_4,_5,_6;
begin
K := Trunc( N/L );
JJ := Trunc( M*L-1 );
JSN := N+1;
I := L;
Q := SYS003/(N);
if ( P ) < 0
 then goto _2
 else if ( P ) > 0
       then goto _1
       else goto _6;
_1:
Q := -Q;
_2:
T := Q*(I+JJ);
C := Cos(T);
S := Sin(T);
CO := C;
SI := S;
JK := JSN-1;
JSN := JSN-K;
JN := JSN+1;
RR := ARE[I-1];
RI := AIM[I-1];
XRE[JSN-1] := RR;
XIM[JSN-1] := RI;
I := I-1;
for J:=JN to JK do
 begin
  XRE[J-1] := RR*CO-RI*SI;
  XIM[J-1] := RI*CO+RR*SI;
  T := C*CO-S*SI;
  SI := C*SI+S*CO;
_3:
  CO := T;
 end;
if ( I ) < 0
 then goto _4
 else if ( I ) > 0
       then goto _2
       else goto _4;
_4:
for I:=1 to K do
 begin
_5:
  FTF1C(XRE,XIM,N,I,K,P);
 end;
_6:
end;

end.
